#ifndef SBDetectorMessenger_h
#define SBDetectorMessenger_h 1

#include "globals.hh"
#include "G4UImessenger.hh"

class SBDetectorConstruction;
class G4UIdirectory;
class G4UIcmdWithAString;
class G4UIcmdWithAnInteger;
class G4UIcmdWithADoubleAndUnit;
class G4UIcmdWithoutParameter;

class SBDetectorMessenger: public G4UImessenger
{
  public:
    SBDetectorMessenger(SBDetectorConstruction* );
   ~SBDetectorMessenger();
    
    void SetNewValue(G4UIcommand*, G4String);
    
  private:
    SBDetectorConstruction* SBDetector;
    
    G4UIdirectory*             SBDir;
    G4UIdirectory*             detDir;

    G4UIcmdWithADoubleAndUnit* OffAxisCmd;
    G4UIcmdWithADoubleAndUnit* OffAxisPhiCmd;

    G4UIcmdWithAString*        TargMaterCmd;
    G4UIcmdWithADoubleAndUnit* TargThickCmd;
    G4UIcmdWithADoubleAndUnit* DiameterCmd;

    G4UIcmdWithAString*        AbsoMaterCmd;
    G4UIcmdWithADoubleAndUnit* AbsoThickCmd;
    G4UIcmdWithADoubleAndUnit* AbsoDiameterCmd;

    G4UIcmdWithADoubleAndUnit* SkinThick1Cmd;
    G4UIcmdWithADoubleAndUnit* SkinThick2Cmd;

    G4UIcmdWithADoubleAndUnit* TunLenCmd;
    G4UIcmdWithADoubleAndUnit* TunRadCmd;

    G4UIcmdWithAnInteger*      NbLayersCmd;
    G4UIcmdWithADoubleAndUnit* MagFieldCmd;
    G4UIcmdWithoutParameter*   UpdateCmd;

    G4UIcmdWithAnInteger*      HornDesCmd;
    G4UIcmdWithAnInteger*      HornInjCmd;
    G4UIcmdWithAnInteger*      HornSkinCmd;
    G4UIcmdWithAnInteger*      HornReflCmd;
    G4UIcmdWithAnInteger*      HornNCmd;

    G4UIcmdWithADoubleAndUnit* HornL1Cmd;
    G4UIcmdWithADoubleAndUnit* HornL2Cmd;
    G4UIcmdWithADoubleAndUnit* HornL3Cmd;
    G4UIcmdWithADoubleAndUnit* HornL4Cmd;
    G4UIcmdWithADoubleAndUnit* HornL5Cmd;
    G4UIcmdWithADoubleAndUnit* HornrCmd;
    G4UIcmdWithADoubleAndUnit* HornRCmd;
    G4UIcmdWithADoubleAndUnit* HornR0Cmd;
    G4UIcmdWithADoubleAndUnit* HornR1Cmd;
    G4UIcmdWithADoubleAndUnit* HornR2Cmd;

    G4UIcmdWithADoubleAndUnit* HornI1Cmd;
    G4UIcmdWithADoubleAndUnit* HornI2Cmd;

    G4UIcmdWithADoubleAndUnit* HornXCmd;
    G4UIcmdWithADoubleAndUnit* HornYCmd;

    G4UIcmdWithADoubleAndUnit* Horn2L1Cmd;
    G4UIcmdWithADoubleAndUnit* Horn2L2Cmd;
    G4UIcmdWithADoubleAndUnit* Horn2L3Cmd;
    G4UIcmdWithADoubleAndUnit* Horn2L4Cmd;
    G4UIcmdWithADoubleAndUnit* Horn2L5Cmd;
    G4UIcmdWithADoubleAndUnit* Horn2rCmd;
    G4UIcmdWithADoubleAndUnit* Horn2RCmd;
    G4UIcmdWithADoubleAndUnit* Horn2R0Cmd;
    G4UIcmdWithADoubleAndUnit* Horn2R1Cmd;
    G4UIcmdWithADoubleAndUnit* Horn2R2Cmd;

    G4UIcmdWithADoubleAndUnit* Horn2DZCmd;

    G4UIcmdWithADoubleAndUnit* TargetDZCmd;
    G4UIcmdWithADoubleAndUnit* AbsoDZCmd;

    G4UIcmdWithAString*        HornFile1Cmd;
    G4UIcmdWithAString*        HornFile2Cmd;

};

#endif

