#ifndef SBRunAction_h
#define SBRunAction_h 1

#include "G4UserRunAction.hh"
#include "SBPrimaryGeneratorAction.hh"
//#include "HistoManager.hh"
//#include "DumpDataROOT.hh"
#include "globals.hh"

#include "TH1F.h"
#include "TH2F.h"
#include "TFile.h"

class G4Run;
class SBRunActionMessenger;
//class DumpDataROOT;
class SBRunAction : public G4UserRunAction
{
public:
  SBRunAction(SBPrimaryGeneratorAction*);
  virtual ~SBRunAction();

  void BeginOfRunAction(const G4Run*);
  void   EndOfRunAction(const G4Run*);
    
  void CheckEOF();
  void fillPerEvent(G4double, G4double, G4double, G4double);
  void fillPerEvent1(G4double, G4double, G4double, G4double,
		     G4double, G4double, G4double, G4double);
  void fillPerEvent1_W(G4double, G4double, G4double, G4double,
		       G4double, G4double, G4double, G4double,G4int,G4int);
  void fillPerEvent2_W(G4double, G4double, G4double, G4double,
		       G4double, G4double, G4double, G4double,
		       G4double, G4double, G4double, G4double,
		       G4double, G4double, G4double, G4double);
  void fillDIF(G4double,
	       G4double,
	       G4double,
	       G4double,
	       G4double,
	       G4double,
	       G4double,
	       G4double,
	       G4double,
	       G4int,
	       G4int);
  void DIFStat(G4double, G4double, G4double, G4double,G4double, G4double);
  void fillEXIT(G4double, G4double, G4double, G4double, G4double, G4double, G4int);
  void fillTARG(G4double/*G4double, G4double, G4double, G4double, G4double, G4double, G4int*/);

  void fillMU(G4double,G4double,G4double,G4int,G4int);

  void FluxesStats();
  void SumFluxesFlavours();
  //void PrepareGLoBESFlux(char*,G4double);
  void PrepareGLoBESFlux(G4String,G4double);
  void DoFinalOps(G4int);

  void SetNbin(G4int val){ENbins = val;};
  void SetEnuMIN(G4double val){EnuMIN = val;};
  void SetEnuMAX(G4double val){EnuMAX = val;};

  //DumpDataROOT* m_hh;

  TFile *fROOT;
  TH1F *h_ETarg;
  TH1F *h_LTarg;

  TH1F *h_p_muplus_PI;
  TH1F *h_p_muminus_PI;
  TH1F *h_p_muplus_K;
  TH1F *h_p_muminus_K;

  G4double rMAX;
  G4double xMAX;
  G4double yMAX;

  G4double zMIN;
  G4double zMAX;

  G4double NDIF_piplus_TOT;
  G4double NDIF_piminus_TOT;
  G4double NDIF_Kplus_TOT;
  G4double NDIF_Kminus_TOT;
  G4double NDIF_KzeroS_TOT;
  G4double NDIF_KzeroL_TOT;

  G4int ENbins;
  G4double EnuMIN;
  G4double EnuMAX;

  int NENB;//9
  //const double ENULIMS[NENB+1];//change if NENB initialized differently ...
  double ENULIMS[10];//change if NENB initialized differently ...
 
  TH1F *pions_numu_du_pi_NW;
  TH1F *pions_anumu_du_pi_NW;
  TH1F *kaons_numu_du_ka_NW;
  TH1F *kaons_anumu_du_ka_NW;

  TH1F *h_G4nue_FAR;
  TH1F *h_G4numu_FAR;
  TH1F *h_G4anue_FAR;
  TH1F *h_G4anumu_FAR;

  TH1F *h_G4nue_NEAR;
  TH1F *h_G4numu_NEAR;
  TH1F *h_G4anue_NEAR;
  TH1F *h_G4anumu_NEAR;

  TH1F *h_G4nue_FARSM;
  TH1F *h_G4numu_FARSM;
  TH1F *h_G4anue_FARSM;
  TH1F *h_G4anumu_FARSM;

  TH1F *h_G4nue_NEARSM;
  TH1F *h_G4numu_NEARSM;
  TH1F *h_G4anue_NEARSM;
  TH1F *h_G4anumu_NEARSM;


  TH1F *h_G4nueX_FAR;
  TH1F *h_G4numuX_FAR;
  TH1F *h_G4anueX_FAR;
  TH1F *h_G4anumuX_FAR;

  TH1F *h_G4nueX_NEAR;
  TH1F *h_G4numuX_NEAR;
  TH1F *h_G4anueX_NEAR;
  TH1F *h_G4anumuX_NEAR;

  TH1F *h_G4nueX_FARSM;
  TH1F *h_G4numuX_FARSM;
  TH1F *h_G4anueX_FARSM;
  TH1F *h_G4anumuX_FARSM;

  TH1F *h_G4nueX_NEARSM;
  TH1F *h_G4numuX_NEARSM;
  TH1F *h_G4anueX_NEARSM;
  TH1F *h_G4anumuX_NEARSM;


  TH1F *h_G4nueY_FAR;
  TH1F *h_G4numuY_FAR;
  TH1F *h_G4anueY_FAR;
  TH1F *h_G4anumuY_FAR;

  TH1F *h_G4nueY_NEAR;
  TH1F *h_G4numuY_NEAR;
  TH1F *h_G4anueY_NEAR;
  TH1F *h_G4anumuY_NEAR;

  TH1F *h_G4nueY_FARSM;
  TH1F *h_G4numuY_FARSM;
  TH1F *h_G4anueY_FARSM;
  TH1F *h_G4anumuY_FARSM;

  TH1F *h_G4nueY_NEARSM;
  TH1F *h_G4numuY_NEARSM;
  TH1F *h_G4anueY_NEARSM;
  TH1F *h_G4anumuY_NEARSM;


  TH2F *h_G4nueXY_FAR;
  TH2F *h_G4numuXY_FAR;
  TH2F *h_G4anueXY_FAR;
  TH2F *h_G4anumuXY_FAR;

  TH2F *h_G4nueXY_NEAR;
  TH2F *h_G4numuXY_NEAR;
  TH2F *h_G4anueXY_NEAR;
  TH2F *h_G4anumuXY_NEAR;

  TH2F *h_G4nueXY_FARSM;
  TH2F *h_G4numuXY_FARSM;
  TH2F *h_G4anueXY_FARSM;
  TH2F *h_G4anumuXY_FARSM;

  TH2F *h_G4nueXY_NEARSM;
  TH2F *h_G4numuXY_NEARSM;
  TH2F *h_G4anueXY_NEARSM;
  TH2F *h_G4anumuXY_NEARSM;



  TH1F *h_G4nueR_FAR;
  TH1F *h_G4numuR_FAR;
  TH1F *h_G4anueR_FAR;
  TH1F *h_G4anumuR_FAR;

  TH1F *h_G4nueR_NEAR;
  TH1F *h_G4numuR_NEAR;
  TH1F *h_G4anueR_NEAR;
  TH1F *h_G4anumuR_NEAR;

  TH1F *h_G4nueR_FARSM;
  TH1F *h_G4numuR_FARSM;
  TH1F *h_G4anueR_FARSM;
  TH1F *h_G4anumuR_FARSM;

  TH1F *h_G4nueR_NEARSM;
  TH1F *h_G4numuR_NEARSM;
  TH1F *h_G4anueR_NEARSM;
  TH1F *h_G4anumuR_NEARSM;


  TH2F *h_G4nueER_FAR;
  TH2F *h_G4numuER_FAR;
  TH2F *h_G4anueER_FAR;
  TH2F *h_G4anumuER_FAR;

  TH2F *h_G4nueER_NEAR;
  TH2F *h_G4numuER_NEAR;
  TH2F *h_G4anueER_NEAR;
  TH2F *h_G4anumuER_NEAR;

  TH2F *h_G4nueER_FARSM;
  TH2F *h_G4numuER_FARSM;
  TH2F *h_G4anueER_FARSM;
  TH2F *h_G4anumuER_FARSM;

  TH2F *h_G4nueER_NEARSM;
  TH2F *h_G4numuER_NEARSM;
  TH2F *h_G4anueER_NEARSM;
  TH2F *h_G4anumuER_NEARSM;


  TH1F *h_G4nue_1;
  TH1F *h_G4nue_2;
  TH1F *h_G4nue_3;
  TH1F *h_G4nue_4;
  TH1F *h_G4nue_5;
  TH1F *h_G4nue_6;
  TH1F *h_G4nue_7;
  TH1F *h_G4nue_8;

  TH1F *h_G4nueOA_1;
  TH1F *h_G4nueOA_2;
  TH1F *h_G4nueOA_3;
  TH1F *h_G4nueOA_4;
  TH1F *h_G4nueOA_5;
  TH1F *h_G4nueOA_6;
  TH1F *h_G4nueOA_7;
  TH1F *h_G4nueOA_8;

  TH1F *h_G4numu_1;
  TH1F *h_G4numu_2;
  TH1F *h_G4numu_3;
  TH1F *h_G4numu_4;
  TH1F *h_G4numu_5;
  TH1F *h_G4numu_6;
  TH1F *h_G4numu_7;
  TH1F *h_G4numu_8;

  TH1F *h_G4numuOA_1;
  TH1F *h_G4numuOA_2;
  TH1F *h_G4numuOA_3;
  TH1F *h_G4numuOA_4;
  TH1F *h_G4numuOA_5;
  TH1F *h_G4numuOA_6;
  TH1F *h_G4numuOA_7;
  TH1F *h_G4numuOA_8;

  TH1F *h_G4anue_1;
  TH1F *h_G4anue_2;
  TH1F *h_G4anue_3;
  TH1F *h_G4anue_4;
  TH1F *h_G4anue_5;
  TH1F *h_G4anue_6;
  TH1F *h_G4anue_7;
  TH1F *h_G4anue_8;

  TH1F *h_G4anueOA_1;
  TH1F *h_G4anueOA_2;
  TH1F *h_G4anueOA_3;
  TH1F *h_G4anueOA_4;
  TH1F *h_G4anueOA_5;
  TH1F *h_G4anueOA_6;
  TH1F *h_G4anueOA_7;
  TH1F *h_G4anueOA_8;

  TH1F *h_G4anumu_1;
  TH1F *h_G4anumu_2;
  TH1F *h_G4anumu_3;
  TH1F *h_G4anumu_4;
  TH1F *h_G4anumu_5;
  TH1F *h_G4anumu_6;
  TH1F *h_G4anumu_7;
  TH1F *h_G4anumu_8;

  TH1F *h_G4anumuOA_1;
  TH1F *h_G4anumuOA_2;
  TH1F *h_G4anumuOA_3;
  TH1F *h_G4anumuOA_4;
  TH1F *h_G4anumuOA_5;
  TH1F *h_G4anumuOA_6;
  TH1F *h_G4anumuOA_7;
  TH1F *h_G4anumuOA_8;

  // neutrino fluxes at far detector

  // pion chain

  TH1F *pions_numu_du_pi_IDEAL;// from direct pi+ decay, IDEAL FOCUSING

  TH1F *pions_numu_du_pi;// from direct pi+ decay
  TH1F *pions_anumu_du_pi;// from direct pi- decay

  TH1F *pions_numu_du_pi_CLONE;// from direct pi+ decay
  TH1F *pions_anumu_du_pi_CLONE;// from direct pi- decay

  TH1F *pions_numu_du_mu;// from decay of mu coming from pi decay
  TH1F *pions_anumu_du_mu;// from decay of mu coming from pi decay
  TH1F *pions_nue_du_mu;// from decay of mu coming from pi decay
  TH1F *pions_anue_du_mu;// from decay of mu coming from pi decay

  // charged kaons chain

  TH1F *kaons_numu_du_ka;// from direct K+ decay
  TH1F *kaons_anumu_du_ka;// from direct K- decay

  TH1F *kaons_numu_du_pi;// from pi+/- coming from the K+-
  TH1F *kaons_anumu_du_pi;// from pi+/- coming from the K+-

  TH1F *kaons_nue_du_mu;// from decay of mu coming from K+/- decay
  TH1F *kaons_anumu_du_mu;// from decay of mu coming from K+/- decay
  TH1F *kaons_anue_du_mu;// from decay of mu coming from K+/- decay
  TH1F *kaons_numu_du_mu;// from decay of mu coming from K+/- decay

  TH1F *kaons_numu_du_3;// from kplus 3 body decays
  TH1F *kaons_anumu_du_3;// from kplus 3 body decays
  TH1F *kaons_nue_du_3;// from kplus 3 body decays
  TH1F *kaons_anue_du_3;// from kplus 3 body decays

  // neutral kaons chain

  TH1F *kzeros_numu_du_pi;// from pions coming from the kzeros
  TH1F *kzeros_anumu_du_pi;// from pions coming from the kzeros
  
  TH1F *kzeros_nue_du_mu;// from muons coming from the kzeros
  TH1F *kzeros_anumu_du_mu;// from muons coming from the kzeros
  TH1F *kzeros_anue_du_mu;// from muons coming from the kzeros
  TH1F *kzeros_numu_du_mu;// from muons coming from the kzeros

  TH1F *kzeros_numu_du_3;// from kzeros 3 body decays
  TH1F *kzeros_anumu_du_3;// from kzeros 3 body decays
  TH1F *kzeros_nue_du_3;// from kzeros 3 body decays
  TH1F *kzeros_anue_du_3;// from kzeros 3 body decays

  //

  TH1F *h_numu;// all
  TH1F *h_anumu;
  TH1F *h_nue;
  TH1F *h_anue;

  //--------------------------------//

  TH1F *h_piminus_DIF_r;
  TH1F *h_piminus_DIF_z;
  TH2F *h_piminus_DIF_xy;
  TH2F *h_piminus_DIF_zr;
  TH2F *h_piminus_DIF_thp;
  TH2F *h_piminus_DIF_thp_EnuW;
  TH2F *h_piminus_DIF_thpinu;
  TH2F *h_piminus_DIF_Ethnu;
  TH1F *h_piminus_DIF_EnuForw;

  TH1F *h_Kminus_DIF_r;
  TH1F *h_Kminus_DIF_z;
  TH2F *h_Kminus_DIF_xy;
  TH2F *h_Kminus_DIF_zr;
  TH2F *h_Kminus_DIF_thp;
  TH2F *h_Kminus_DIF_thp_EnuW;
  TH2F *h_Kminus_DIF_thpinu;
  TH2F *h_Kminus_DIF_Ethnu;
  TH1F *h_Kminus_DIF_EnuForw;

  TH1F *h_piplus_DIF_r;
  TH1F *h_piplus_DIF_z;
  TH2F *h_piplus_DIF_xy;
  TH2F *h_piplus_DIF_zr;
  TH2F *h_piplus_DIF_thp;
  TH2F *h_piplus_DIF_thp_EnuW;  
  TH2F *h_piplus_DIF_thpinu;
  TH2F *h_piplus_DIF_Ethnu;
  TH1F *h_piplus_DIF_EnuForw;

  TH1F *h_Kplus_DIF_r;
  TH1F *h_Kplus_DIF_z;
  TH2F *h_Kplus_DIF_xy;
  TH2F *h_Kplus_DIF_zr;
  TH2F *h_Kplus_DIF_thp;
  TH2F *h_Kplus_DIF_thp_EnuW;
  TH2F *h_Kplus_DIF_thpinu;
  TH2F *h_Kplus_DIF_Ethnu;
  TH1F *h_Kplus_DIF_EnuForw;

  // quantities at the exit of the horn

  TH1F *h_pt_exit_piplus;
  TH1F *h_p_exit_piplus;
  TH2F *h_xy_exit_piplus;
  TH1F *h_z_exit_piplus;
  TH1F *h_r_exit_piplus;
  TH2F *h_pVSr_exit_piplus;
  TH2F *h_pVStheta_exit_piplus;
  TH2F *h_thetaVSr_exit_piplus;
  TH1F *h_theta_exit_piplus;
  TH2F *h_pVStheta_exit_piplus_W;

  TH1F *h_pt_exit_piminus;
  TH1F *h_p_exit_piminus;
  TH2F *h_xy_exit_piminus;
  TH1F *h_z_exit_piminus;
  TH1F *h_r_exit_piminus;
  TH2F *h_pVSr_exit_piminus;
  TH2F *h_pVStheta_exit_piminus;
  TH2F *h_thetaVSr_exit_piminus;
  TH1F *h_theta_exit_piminus;

  TH1F *h_pt_exit_kplus;
  TH1F *h_p_exit_kplus;
  TH2F *h_xy_exit_kplus;
  TH1F *h_z_exit_kplus;
  TH1F *h_r_exit_kplus;
  TH2F *h_pVSr_exit_kplus;
  TH2F *h_pVStheta_exit_kplus;
  TH2F *h_thetaVSr_exit_kplus;
  TH1F *h_theta_exit_kplus;

  TH1F *h_pt_exit_kminus;
  TH1F *h_p_exit_kminus;
  TH2F *h_xy_exit_kminus;
  TH1F *h_z_exit_kminus;
  TH1F *h_r_exit_kminus;
  TH2F *h_pVSr_exit_kminus;
  TH2F *h_pVStheta_exit_kminus;
  TH2F *h_thetaVSr_exit_kminus;
  TH1F *h_theta_exit_kminus;

  TH1F *h_pt_exit_muplus;
  TH1F *h_p_exit_muplus;
  TH2F *h_xy_exit_muplus;
  TH1F *h_z_exit_muplus;
  TH1F *h_r_exit_muplus;
  TH2F *h_pVSr_exit_muplus;
  TH2F *h_pVStheta_exit_muplus;
  TH2F *h_thetaVSr_exit_muplus;
  TH1F *h_theta_exit_muplus;

  TH1F *h_pt_exit_muminus;
  TH1F *h_p_exit_muminus;
  TH2F *h_xy_exit_muminus;
  TH1F *h_z_exit_muminus;
  TH1F *h_r_exit_muminus;
  TH2F *h_pVSr_exit_muminus;
  TH2F *h_pVStheta_exit_muminus;
  TH2F *h_thetaVSr_exit_muminus;
  TH1F *h_theta_exit_muminus;

  TH1F *h_pt_exit_k0L;
  TH1F *h_p_exit_k0L;
  TH2F *h_xy_exit_k0L;
  TH1F *h_z_exit_k0L;
  TH1F *h_r_exit_k0L;
  TH2F *h_pVSr_exit_k0L;
  TH2F *h_pVStheta_exit_k0L;
  TH2F *h_thetaVSr_exit_k0L;
  TH1F *h_theta_exit_k0L;

  TH1F *h_pt_targ_piplus;
  TH1F *h_p_targ_piplus;
  TH1F *h_z_targ_piplus;
  TH1F *h_zabs_targ_piplus;
  TH1F *h_theta_targ_piplus;
  TH2F *h_pVStheta_targ_piplus;
  TH2F *h_pVStheta_targ_piplus_Enubins[9];//NENB
  TH1F *h_p_targ_piplus_Enubins[9];
  TH1F *h_theta_targ_piplus_Enubins[9];

  TH1F *h_pt_targ_piminus;
  TH1F *h_p_targ_piminus;
  TH1F *h_z_targ_piminus;
  TH1F *h_zabs_targ_piminus;
  TH1F *h_theta_targ_piminus;
  TH2F *h_pVStheta_targ_piminus;
  TH2F *h_pVStheta_targ_piminus_Enubins[9];//NENB
  TH1F *h_p_targ_piminus_Enubins[9];
  TH1F *h_theta_targ_piminus_Enubins[9];

  TH1F *h_MUDEC_Enumustar;
  TH1F *h_MUDEC_Enuestar;
  TH1F *h_MUDEC_Eanumustar;
  TH1F *h_MUDEC_Eanuestar;
  //TH1F *h_MUDEC_Eeplusstar;
  //TH1F *h_MUDEC_Eeminusstar;
  //TH1F *h_MUDEC_costhstarmu;
  //TH1F *h_MUDEC_costhstareplus;

  TH1F *h_MUDEC_probaTunnel;
  TH1F *h_MUDEC_pathTunnel;

  TH2F *h_MUDEC_probaTunnel_pmu;
  TH2F *h_MUDEC_probaTunnel_thmu;
  TH2F *h_MUDEC_probaTunnel_rmu;

  TH2F *h_MUDEC_muxy;
  TH2F *h_MUDEC_muzr;

  TH1F *h_MUDEC_cthstarMu;
  TH1F *h_MUDEC_cthstarNu;

  TH1F *h_MUDEC_polaL_muplus;
  TH1F *h_MUDEC_polaL_muminus;
  TH1F *h_MUDEC_thpimu_lab;

  TH2F *h_MUDEC_pmupar;

  TH2F *h_geom_g4;

  TH1F *h_decay_flags;
  TH1F *h_decay_NUM;
  TH1F *h_decay_BR;
  TH1F *h_decay_BR_PDG;

  TH2F *h_prim_match_pi;
  TH2F *h_prim_match_ka;
  TH2F *h_prim_match_k0;

private:

  SBRunActionMessenger* runActMessenger;//messenger of this class
  G4double sumETarg, sum2ETarg;
  G4double sumEGap, sum2EGap;
    
  G4double sumLTarg, sum2LTarg;
  G4double sumLGap, sum2LGap;    

  SBPrimaryGeneratorAction* primaryGen;

  //HistoManager* histoManager;

};

#endif

