#include "SBField.hh"
#include "SBDetectorConstruction.hh"

SBField::SBField(G4double I0, G4int hID, SBDetectorConstruction* SBDC):SBDetector(SBDC)
//SBField::SBField(G4double I0=0)
{
  //I0 = 300000.*ampere;
  //R0 = 4.*cm;//InCondRad[0] + InCondDepth[1];
  G4double MU04PI = 1.e-7*(tesla*m)/ampere;
  K0=MU04PI *2.*I0;

  G4cout << "I0 = " <<I0/ampere <<" A "<<G4endl; 

  x0 = SBDetector->GetHornX();
  y0 = SBDetector->GetHornY();

  //if(hID==0){;}
  if(hID==1){x0*=-1.;}
  if(hID==2){y0*=-1.;}
  if(hID==3){x0*=-1.;y0*=-1.;}

  G4cout <<"SBField: Horn position (x,y) cm "<< x0/cm <<" "<<y0/cm<<G4endl;

}

SBField::~SBField(){;}

void SBField::GetFieldValue(const G4double point[3],G4double *Bfield) const
{
  G4bool DEB=false;
  G4double r = 0*cm;
  //r=sqrt(point[0]*point[0]+point[1]*point[1]);
  r=sqrt(((point[0]-x0)*(point[0]-x0))+((point[1]-y0)*(point[1]-y0)));
  //r=sqrt(((point[0])*(point[0]))+((point[1])*(point[1])));

  //G4cout << r/cm <<" cm" << G4endl;
 
  if(
     (r>1*cm) //&& 
     ////std::abs(point[2])<zmax && 
     //(sqr(point[0])+sqr(point[1]))<rmax_sq
     )
    //if((sqr(point[0])+sqr(point[1]))<rmax_sq)
  {
    //Bfield[0] = -(K0/r)*(point[1]/r);
    //Bfield[1] =  (K0/r)*(point[0]/r);
    Bfield[0] = -(K0/r)*((point[1]-y0)/r);
    Bfield[1] =  (K0/r)*((point[0]-x0)/r);
    Bfield[2] = 0;    
  } else { 
    Bfield[0] = 0.;
    Bfield[1] = 0.;
    Bfield[2] = 0.; 
  }

  // test
  //Bfield[0] = 5.*tesla;
  //Bfield[1] = 0;
  //Bfield[2] = 0;    


   if(DEB)G4cout <<"x "<<point[0]/cm<<" (cm) y "<<point[1]/cm<<" (cm) z "<<point[2]/cm<<" (cm) Bx " << Bfield[0]/tesla <<" (T) By "<<Bfield[1]/tesla<<" (T) Bz "<<Bfield[2]/tesla<<" (T)"<<G4endl;


   //G4cout <<"TESTBFIELD "<<r/cm<<" "<< sqrt(Bfield[0]*Bfield[0]+Bfield[1]*Bfield[1])/tesla << G4endl;


}

